<?php

/*

  File: message.php3
  $Author: mpb $
  $Revision: 1.9 $
  $Date: 1998/08/24 04:28:37 $
  
  IMP : Copyright 1998 Charles J. Hagenbuch <chuck@osmos.ml.org>
  
  This code is under the GNU Public License
  See the file COPYING in this directory
  
*/
  
  require( './lib/imp.lib.php3' );      /* IMPlib is the IMP function library */
  require( './config/defaults.php3' );  /* Defaults configuration file */
  
  error_reporting($default->error_level);  /* set error level from imp.lib.php3   */
  header('Expires: 120');         /* make the page expire in 2 minutes   */
  
  $user    = getuser();
  $pass    = getpass();
  $folders = getfldr();
  $server  = getsrvr();
  if (!$mailbox) { $mailbox = 'INBOX'; }
  $current_mbox = eregi_replace("{$server}$folders/*", '', $mailbox);
  
  $mbox = validate_login($server, $mailbox, $user, $pass);
  
  
  /* Run through action handlers */
  
  if (isset($action)) {
    switch ($action) {
      case NO_ACTION:
        break;
      
      case DELETE_MESSAGES:
        if ($index && $mailbox) {
	  if (!(imap_delete($mbox, $index))) {
	    $errormsg = '<tr><th colspan=2>An error occured; your message has not been deleted.</td></tr>';
	  }
	  $index++;
	}
	break;
    }
  }
  
  
  /* parse MIME header info */
  
  $structure = imap_fetchstructure($mbox, $index);
  $num_parts = count($structure->parts);
  
  if ($bodypart < 1) {$bodypart = 1;}
  if ($num_parts > 0) {
    $j = 1;
    
    while ($j <= $num_parts) {
      $part = $structure->parts[$j];
      $size = $part->bytes;
      $ksize = sprintf ("%0.2f",$size / 1024);
      $encoding = $part->encoding;
      
      if ($part->ifdparametres) {
        $parameters = $part->dparametres;
	$name = $parameters[0]->value;
      }
      
      elseif ($part->ifparametres) {
        $parameters = $part->parametres;
	$name = $parameters[0]->value;
      }
      
      if (!$parameters[0]->value) { $name = 'attachment ' . $j; }
      
      if ($size != 0) {
        $atc .= "<a href=view.php3?mailbox=$mailbox&index=$index&bodypart=$j&action=" . VIEW_ATTACH . ">$name</a> - ";
	$atc .= $ksize . 'kB';
	
	if ($encoding == 3) { $atc .= " - MIME 1.0 Encoding"; }
	
	$atc .= " <a href=" . $default->root_url . "/view.php3?mailbox=$mailbox&index=$index&bodypart=$j&action=" . DOWNLOAD_ATTACH . ">(download)</a><br>";
      }
      
      $j++;
    }
  }
  
  /* get and format the main body part */
  $msg = htmlentities(fill_paragraphs(imap_fetchbody($mbox, $index, $bodypart)));
  
  $title = "$mailbox: $subject";
  include( "$default->include_dir/generic-header.inc" );
  
  $prev = $index - 1;
  $next = $index + 1;
  if ($index != imap_num_msg($mbox)) { $del_target = 'message.php3';
                                       $del_ident  = 'index'; }
  else { $del_target = 'mailbox.php3';
         $del_ident  = 'indices'; }
  
  include( "$default->include_dir/message.php3-navbar.inc" );
  
  $h = imap_header($mbox, $index);
  
  $dat = htmlentities(chop($h->date ));
  $to  = htmlentities(decode_mime_string(chop($h->toaddress )));
  $frm = htmlentities(decode_mime_string(chop($h->fromaddress )));
  $cc  = htmlentities(decode_mime_string(chop($h->ccaddress )));
  $rep = htmlentities(decode_mime_string(chop($h->reply_toaddress )));
  $sub = htmlentities(decode_mime_string(chop($h->subject )));
 
  include( "$default->include_dir/message.php3-headers.inc" );
  
  $msg = eregi_replace( "(http|https|ftp)://([-=%_a-zA-Z0-9\./~\?]+)", "<a href=\"\\1://\\2\" target=\"_blank\">\\1://\\2</a>", $msg);
  
  include( "$default->include_dir/message.php3-message.inc" );
  include( "$default->include_dir/message.php3-navbar.inc" );
  include( "$default->include_dir/generic-footer.inc" );
?>
